/'****************************************************************************
*
* Name: TestTable.bas
*
* Synopsis: Test program for table object.
*
* Description: This program tests the various features of the table object.
*
* Copyright 2009, Richard D. Clark
*
*                          The Wide Open License (WOL)
*
* Permission to use, copy, modify, distribute and sell this software and its
* documentation for any purpose is hereby granted without fee, provided that
* the above copyright notice and this license appear in all source copies. 
* THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY OF
* ANY KIND. See http://www.dspguru.com/wol.htm for more information.
*
*****************************************************************************'/
#Include "tableobj.bi"

'Create table object.
Dim myTable As tableobj.tblobj
Dim myCell As tableobj.tcell
Dim clbyte As Byte = -127 'Data Values.
Dim clubyte As UByte = 127   
Dim clshort As Short = -1000
Dim clushort As UShort = 1000
Dim clinteger As Integer = -200000  
Dim cluinteger As UInteger = 200000 
Dim cllong As Long = -300000000  
Dim clulong As ULong = 3000000000 
Dim cllongint As LongInt = -40000000000 
Dim clulongint As ULongInt = 40000000000 
Dim clsingle As Single = -100.2345 
Dim cldouble As Double = 2345.6789 
Dim clstring As String = "This is a string value."
Dim As Integer row, col
Dim ct As tableobj.cdatatype
Dim er As tableobj.ecodes

Print "Version: " & myTable.Version

'Add a couple of rows to the table.
For i As Integer = 1 To 2
    row = myTable.AddRow ()
    
    er = myTable.ErrorCode 
    If  er <> tableobj.etNoError Then
    	Print myTable.ErrorString (er)
    EndIf
    
    myCell = clbyte 
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clubyte
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clshort
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clushort
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clinteger
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = cluinteger
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = cllong
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clulong
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."
    
    myCell = cllongint
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clulongint
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clsingle
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."
    
    myCell = cldouble
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."

    myCell = clstring
    col = myTable.AddColumn (row, myCell)
    Print "Row " & row & " Col " & col & " added."
    
Next

clbyte = 0
clubyte = 0   
clshort = 0
clushort = 0
clinteger = 0  
cluinteger = 0 
cllong = 0  
clulong = 0 
cllongint = 0 
clulongint = 0 
clsingle = 0 
cldouble = 0 
clstring = ""


'Print out column data.
row = myTable.RowCount
Print "Number of rows: " & row
For i As Integer = 0 To row - 1
    col = myTable.ColCount(i)
    Print "Number of cols: " & col
    For j As Integer = 0 To col - 1
        myTable.GetColData i, j, myCell
        'Get the data type.
        ct = myCell.DataType
        Select Case ct
            Case tableobj.tByte
                clbyte = myCell
                Print "Col " & j & ": " & clbyte  
            Case tableobj.tUByte
                clubyte = myCell
                Print "Col " & j & ": " & clubyte  
            Case tableobj.tShort
                clshort = myCell
                Print "Col " & j & ": " & clshort  
            Case tableobj.tUShort
                clushort = myCell
                Print "Col " & j & ": " & clushort  
            Case tableobj.tInteger
                clinteger = myCell
                Print "Col " & j & ": " & clinteger  
            Case tableobj.tUInteger
                cluinteger = myCell
                Print "Col " & j & ": " & cluinteger  
            Case tableobj.tLong
                cllong = myCell
                Print "Col " & j & ": " & cllong  
            Case tableobj.tUlong
                clulong = myCell
                Print "Col " & j & ": " & clulong  
            Case tableobj.tLongint
                cllongint = myCell
                Print "Col " & j & ": " & cllongint  
            Case tableobj.tUlongint
                clulongint = myCell
                Print "Col " & j & ": " & clulongint  
            Case tableobj.tSingle
                clsingle = myCell
                Print "Col " & j & ": " & clsingle  
            Case tableobj.tDouble
                cldouble = myCell
                Print "Col " & j & ": " & cldouble  
            Case tableobj.tString
                clstring = myCell
                Print "Col " & j & ": " & clstring  
        End Select
    Next
Next 

Print
myCell = 30
'Check the data type of constant-s/b Integer.
If myCell.DataType = tableobj.tInteger Then
	Print "Saved as integer."
EndIf
Print
'Set Colun 0 in Row 0 to 30.
myTable.SetColData 0, 0, myCell
myCell.ClearCell
myTable.GetColData 0, 0, myCell
clinteger = myCell
Print clinteger
'Clear Column.
Print
myCell.ClearCell
myTable.ClearCol 0, 0
myTable.GetColData 0, 0, myCell
If myCell.DataType = tableobj.tNull Then
	Print "Column now Null."
EndIf

'Destroy table.
Print
myTable.DestroyTable
Print "Table destroyed. Rows: " & myTable.RowCount
Sleep
